package cn.iocoder.yudao.module.system.controller.admin.home;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServiceDepartmentPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServiceDepartmentRespVO;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServiceDepartmentSaveReqVO;
import cn.iocoder.yudao.module.system.service.home.HomeServiceDepartmentService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 居家服务部门")
@RestController
@RequestMapping("/home/service-department")
@Validated
public class HomeServiceDepartmentController {

    @Resource
    private HomeServiceDepartmentService homeServiceDepartmentService;

    @PostMapping("/create")
    @Operation(summary = "新增居家服务部门")
    @TenantIgnore
    public CommonResult<Long> create(@Valid @RequestBody HomeServiceDepartmentSaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(homeServiceDepartmentService.createHomeServiceDepartment(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "修改居家服务部门")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody HomeServiceDepartmentSaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        homeServiceDepartmentService.updateHomeServiceDepartment(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除居家服务部门")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        homeServiceDepartmentService.deleteHomeServiceDepartment(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得居家服务部门详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<HomeServiceDepartmentRespVO> get(@RequestParam("id") Long id) {
        return success(homeServiceDepartmentService.getHomeServiceDepartment(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得居家服务部门分页")
    @TenantIgnore
    public CommonResult<PageResult<HomeServiceDepartmentRespVO>> page(@Valid HomeServiceDepartmentPageReqVO pageReqVO) {
        if (pageReqVO.getTenantId() == null) {
            pageReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(homeServiceDepartmentService.getHomeServiceDepartmentPage(pageReqVO));
    }
}
